xine-lib: xine-lib-1.2.12/src/post/goom/tentacle3d.c File Reference

xine-lib 1.2.12

Data Structures | Macros | Typedefs | Functions
tentacle3d.c File Reference
`#include <stdlib.h>`
`#include "v3d.h"`
`#include "surf3d.h"`
`#include "goom_tools.h"`
`#include "goom_config.h"`
`#include "goom_plugin_info.h"`
`#include "tentacle3d.h"`

## Data Structures
struct | _TENTACLE_FX_DATA

## Macros
#define | D 256.0f
#define | nbgrid 6
#define | definitionx 9
#define | definitionz 45
#define | NB_TENTACLE_COLORS 4
#define | ShiftRight(_x, _s) ((_x<0) ? -(-_x>>_s) : (_x>>_s))

## Typedefs
typedef struct _TENTACLE_FX_DATA | TentacleFXData

## Functions
static void | tentacle_new (TentacleFXData *data)
static void | tentacle_update (PluginInfo *goomInfo, Pixel *buf, Pixel *back, int W, int H, short[2][512], float, int drawit, TentacleFXData *data)
static void | tentacle_free (TentacleFXData *data)
static void | tentacle_fx_init (VisualFX *_this, PluginInfo *info)
static void | tentacle_fx_apply (VisualFX *_this, Pixel *src, Pixel *dest, PluginInfo *goomInfo)
static void | tentacle_fx_free (VisualFX *_this)
VisualFX | tentacle_fx_create (void)
static unsigned char | lighten (unsigned char value, float power)
static void | lightencolor (int *col, float power)
static int | evolutecolor (unsigned int src, unsigned int dest, unsigned int mask, unsigned int incr)
static void | pretty_move (PluginInfo *goomInfo, float cycle, float *dist, float *dist2, float *rotangle, TentacleFXData *fx_data)

## Macro Definition Documentation

## ◆ D

#define D 256.0f

## ◆ definitionx

#define definitionx 9

## ◆ definitionz

#define definitionz 45

## ◆ NB_TENTACLE_COLORS

#define NB_TENTACLE_COLORS 4

## ◆ nbgrid

#define nbgrid 6

## ◆ ShiftRight

#define ShiftRight | ( |  | _x,
|  |  | _s
| ) |  | ((_x<0) ? -(-_x>>_s) : (_x>>_s))

## Typedef Documentation

## ◆ TentacleFXData

typedef struct _TENTACLE_FX_DATA TentacleFXData

## Function Documentation

## ◆ evolutecolor()

static int evolutecolor | ( | unsigned int | src,
|  | unsigned int | dest,
|  | unsigned int | mask,
|  | unsigned int | incr
| ) |  |
| static

Referenced by tentacle_update().

## ◆ lighten()

static unsigned char lighten | ( | unsigned char | value,
|  | float | power
| ) |  |
| inlinestatic

Referenced by lightencolor().

## ◆ lightencolor()

static void lightencolor | ( | int * | col,
|  | float | power
| ) |  |
| static

References lighten().

Referenced by tentacle_update().

## ◆ pretty_move()

static void pretty_move | ( | PluginInfo * | goomInfo,
|  | float | cycle,
|  | float * | dist,
|  | float * | dist2,
|  | float * | rotangle,
|  | TentacleFXData * | fx_data
| ) |  |
| static

References D, _TENTACLE_FX_DATA::distt, _TENTACLE_FX_DATA::distt2, goom_irand(), _PLUGIN_INFO::gRandom, _TENTACLE_FX_DATA::happens, _TENTACLE_FX_DATA::lock, _TENTACLE_FX_DATA::rot, and _TENTACLE_FX_DATA::rotation.

Referenced by tentacle_update().

## ◆ tentacle_free()

static void tentacle_free | ( | TentacleFXData * | data | ) |
| static

References grid3d_free(), _TENTACLE_FX_DATA::grille, nbgrid, and _TENTACLE_FX_DATA::vals.

Referenced by tentacle_fx_free().

## ◆ tentacle_fx_apply()

static void tentacle_fx_apply | ( | VisualFX * | _this,
|  | Pixel * | src,
|  | Pixel * | dest,
|  | PluginInfo * | goomInfo
| ) |  |
| static

References _SOUND_INFO::accelvar, BVAL, _PLUGIN_INFO::curGState, GoomState::drawTentacle, _TENTACLE_FX_DATA::enabled_bp, _VISUAL_FX::fx_data, _PLUGIN_INFO::_SIZE_TYPE::height, _SOUND_INFO::samples, _PLUGIN_INFO::screen, _PLUGIN_INFO::sound, tentacle_update(), and _PLUGIN_INFO::_SIZE_TYPE::width.

Referenced by tentacle_fx_create().

## ◆ tentacle_fx_create()

VisualFX tentacle_fx_create | ( | void |  | ) |

References _VISUAL_FX::init, tentacle_fx_apply(), tentacle_fx_free(), and tentacle_fx_init().

Referenced by goom_init().

## ◆ tentacle_fx_free()

static void tentacle_fx_free | ( | VisualFX * | _this | ) |
| static

References _VISUAL_FX::fx_data, _PARAMETERS::params, _TENTACLE_FX_DATA::params, and tentacle_free().

Referenced by tentacle_fx_create().

## ◆ tentacle_fx_init()

static void tentacle_fx_init | ( | VisualFX * | _this,
|  | PluginInfo * | info
| ) |  |
| static

References BLEU, _TENTACLE_FX_DATA::col, _TENTACLE_FX_DATA::colors, _TENTACLE_FX_DATA::cycle, _TENTACLE_FX_DATA::distt, _TENTACLE_FX_DATA::distt2, _TENTACLE_FX_DATA::dstcol, _TENTACLE_FX_DATA::enabled_bp, _VISUAL_FX::fx_data, _TENTACLE_FX_DATA::happens, _TENTACLE_FX_DATA::lig, _TENTACLE_FX_DATA::ligs, _TENTACLE_FX_DATA::lock, _PARAMETERS::params, _VISUAL_FX::params, _TENTACLE_FX_DATA::params, plugin_parameters, _TENTACLE_FX_DATA::rot, _TENTACLE_FX_DATA::rotation, ROUGE, secure_b_param, tentacle_new(), and VERT.

Referenced by tentacle_fx_create().

## ◆ tentacle_new()

static void tentacle_new | ( | TentacleFXData * | data | ) |
| static

References definitionx, definitionz, grid3d_new(), _TENTACLE_FX_DATA::grille, nbgrid, _TENTACLE_FX_DATA::vals, v3d::y, v3d::z, and z.

Referenced by tentacle_fx_init().

## ◆ tentacle_update()

static void tentacle_update | ( | PluginInfo * | goomInfo,
|  | Pixel * | buf,
|  | Pixel * | back,
|  | int | W,
|  | int | H,
|  | short | data[2][512],
|  | float | rapport,
|  | int | drawit,
|  | TentacleFXData * | data
| ) |  |
| static

References _TENTACLE_FX_DATA::col, _TENTACLE_FX_DATA::colors, _TENTACLE_FX_DATA::cycle, definitionx, _TENTACLE_FX_DATA::dstcol, evolutecolor(), goom_irand(), _PLUGIN_INFO::gRandom, grid3d_draw(), grid3d_update(), _TENTACLE_FX_DATA::grille, _TENTACLE_FX_DATA::lig, lightencolor(), _TENTACLE_FX_DATA::ligs, NB_TENTACLE_COLORS, nbgrid, pretty_move(), ShiftRight, and _TENTACLE_FX_DATA::vals.

Referenced by tentacle_fx_apply().